# Generated by using Rcpp::compileAttributes() -> do not edit by hand
# Generator token: 10BE3573-1514-4C36-9D1C-5A225CD40393

vectorize <- function(mat, axis) {
    .Call('ziphsmm_vectorize', PACKAGE = 'ziphsmm', mat, axis)
}

vec2mat <- function(vec, row, col, axis) {
    .Call('ziphsmm_vec2mat', PACKAGE = 'ziphsmm', vec, row, col, axis)
}

colsum <- function(matrix) {
    .Call('ziphsmm_colsum', PACKAGE = 'ziphsmm', matrix)
}

rowsum <- function(matrix) {
    .Call('ziphsmm_rowsum', PACKAGE = 'ziphsmm', matrix)
}

subsetmatrix <- function(rawmat, rowindex, colindex) {
    .Call('ziphsmm_subsetmatrix', PACKAGE = 'ziphsmm', rawmat, rowindex, colindex)
}

matrixpower <- function(oldmat, power) {
    .Call('ziphsmm_matrixpower', PACKAGE = 'ziphsmm', oldmat, power)
}

matrixexp <- function(oldmat, t) {
    .Call('ziphsmm_matrixexp', PACKAGE = 'ziphsmm', oldmat, t)
}

matrixsum <- function(mat1, mat2) {
    .Call('ziphsmm_matrixsum', PACKAGE = 'ziphsmm', mat1, mat2)
}

matrixintegral <- function(Q, interval, x, y) {
    .Call('ziphsmm_matrixintegral', PACKAGE = 'ziphsmm', Q, interval, x, y)
}

#' pmf for zero-inflated poisson
#' @param p proportion of structural zero's
#' @param theta the poisson mean
#' @param y the observed value
#' @param loga Logical. Whether to return the log probability or not.
#' @return the probability mass of the zero-inflated poisson distribution
#' @export
dzip <- function(p, theta, y, loga) {
    .Call('ziphsmm_dzip', PACKAGE = 'ziphsmm', p, theta, y, loga)
}

#' generate zero-inflated poisson random variables
#' @param n length of the random series
#' @param p proportion of structural zero's
#' @param theta the poisson mean
#' @return a series of zero-inflated poisson random variables
#' @export
rzip <- function(n, p, theta) {
    .Call('ziphsmm_rzip', PACKAGE = 'ziphsmm', n, p, theta)
}

rshiftpois <- function(n, theta, shift) {
    .Call('ziphsmm_rshiftpois', PACKAGE = 'ziphsmm', n, theta, shift)
}

dshiftpois <- function(x, theta, shift, loga) {
    .Call('ziphsmm_dshiftpois', PACKAGE = 'ziphsmm', x, theta, shift, loga)
}

dlogp <- function(x, p, loga) {
    .Call('ziphsmm_dlogp', PACKAGE = 'ziphsmm', x, p, loga)
}

rlogp <- function(n, p) {
    .Call('ziphsmm_rlogp', PACKAGE = 'ziphsmm', n, p)
}

multinomrand <- function(n, k, prob, label) {
    .Call('ziphsmm_multinomrand', PACKAGE = 'ziphsmm', n, k, prob, label)
}

hsmm_hmm <- function(omega, dm, mv) {
    .Call('ziphsmm_hsmm_hmm', PACKAGE = 'ziphsmm', omega, dm, mv)
}

hmm_gen <- function(dim, M, ntimes, pi, a, theta, zeroprop) {
    .Call('ziphsmm_hmm_gen', PACKAGE = 'ziphsmm', dim, M, ntimes, pi, a, theta, zeroprop)
}

getnodeprob_nocov <- function(ystar, emit) {
    .Call('ziphsmm_getnodeprob_nocov', PACKAGE = 'ziphsmm', ystar, emit)
}

getnodeprob_cov <- function(y, x, zerovec, emitmat, m) {
    .Call('ziphsmm_getnodeprob_cov', PACKAGE = 'ziphsmm', y, x, zerovec, emitmat, m)
}

hmm_cov_gen <- function(parm, M, dim, ncolcovpi, covpi, ncolcovtrans, covtrans, ncolcovp1, covp1, ncolcovpois, covpois, zeroindex) {
    .Call('ziphsmm_hmm_cov_gen', PACKAGE = 'ziphsmm', parm, M, dim, ncolcovpi, covpi, ncolcovtrans, covtrans, ncolcovp1, covp1, ncolcovpois, covpois, zeroindex)
}

hsmm_gen <- function(dim, M, pi, theta, zeroprop, omega, p, dt_dist) {
    .Call('ziphsmm_hsmm_gen', PACKAGE = 'ziphsmm', dim, M, pi, theta, zeroprop, omega, p, dt_dist)
}

hsmm_cov_gen <- function(parm, M, dim, dt_dist, zeroindex, ncolcovp, covp, ncolcovpi, covpi, ncolcovomega, covomega, ncolcovp1, covp1, ncolcovpois, covpois) {
    .Call('ziphsmm_hsmm_cov_gen', PACKAGE = 'ziphsmm', parm, M, dim, dt_dist, zeroindex, ncolcovp, covp, ncolcovpi, covpi, ncolcovomega, covomega, ncolcovp1, covp1, ncolcovpois, covpois)
}

hmm_nllk <- function(parm, M, y, zeroindex) {
    .Call('ziphsmm_hmm_nllk', PACKAGE = 'ziphsmm', parm, M, y, zeroindex)
}

hmm_common_nocov_negloglik <- function(allparm, M, ally, ntimes, zeroindex) {
    .Call('ziphsmm_hmm_common_nocov_negloglik', PACKAGE = 'ziphsmm', allparm, M, ally, ntimes, zeroindex)
}

hmm_cov_negloglik <- function(parm, M, y, ncolcovpi, covpi, ncolcovtrans, covtrans, ncolcovp1, covp1, ncolcovpois, covpois, zeroindex) {
    .Call('ziphsmm_hmm_cov_negloglik', PACKAGE = 'ziphsmm', parm, M, y, ncolcovpi, covpi, ncolcovtrans, covtrans, ncolcovp1, covp1, ncolcovpois, covpois, zeroindex)
}

hmm_common_negloglik <- function(allparm, M, ally, ntimes, ncolcovpi, allcovpi, ncolcovtrans, allcovtrans, ncolcovp1, allcovp1, ncolcovpois, allcovpois, zeroindex) {
    .Call('ziphsmm_hmm_common_negloglik', PACKAGE = 'ziphsmm', allparm, M, ally, ntimes, ncolcovpi, allcovpi, ncolcovtrans, allcovtrans, ncolcovp1, allcovp1, ncolcovpois, allcovpois, zeroindex)
}

hsmm_nllk <- function(parm, M, trunc, y, dt_dist, zeroindex) {
    .Call('ziphsmm_hsmm_nllk', PACKAGE = 'ziphsmm', parm, M, trunc, y, dt_dist, zeroindex)
}

hsmm_common_nocov_nllk <- function(allparm, M, ally, trunc, ntimes, dt_dist, zeroprop) {
    .Call('ziphsmm_hsmm_common_nocov_nllk', PACKAGE = 'ziphsmm', allparm, M, ally, trunc, ntimes, dt_dist, zeroprop)
}

hsmm_cov_nllk <- function(parm, M, y, trunc, dt_dist, zeroindex, ncolcovp, covp, ncolcovpi, covpi, ncolcovomega, covomega, ncolcovp1, covp1, ncolcovpois, covpois) {
    .Call('ziphsmm_hsmm_cov_nllk', PACKAGE = 'ziphsmm', parm, M, y, trunc, dt_dist, zeroindex, ncolcovp, covp, ncolcovpi, covpi, ncolcovomega, covomega, ncolcovp1, covp1, ncolcovpois, covpois)
}

hsmm_common_negloglik <- function(allparm, M, ally, trunc, ntimes, dt_dist, zeroindex, ncolcovp, allcovp, ncolcovpi, allcovpi, ncolcovomega, allcovomega, ncolcovp1, allcovp1, ncolcovpois, allcovpois) {
    .Call('ziphsmm_hsmm_common_negloglik', PACKAGE = 'ziphsmm', allparm, M, ally, trunc, ntimes, dt_dist, zeroindex, ncolcovp, allcovp, ncolcovpi, allcovpi, ncolcovomega, allcovomega, ncolcovp1, allcovp1, ncolcovpois, allcovpois)
}

hmm_viterbi <- function(pi, a, theta, M, y, zeroprop) {
    .Call('ziphsmm_hmm_viterbi', PACKAGE = 'ziphsmm', pi, a, theta, M, y, zeroprop)
}

hsmm_viterbi <- function(y, M, pi, theta, omega, p, trunc, dt_dist, zeroprop) {
    .Call('ziphsmm_hsmm_viterbi', PACKAGE = 'ziphsmm', y, M, pi, theta, omega, p, trunc, dt_dist, zeroprop)
}

hmm_cov_viterbi <- function(parm, M, y, ncolcovpi, covpi, ncolcovtrans, covtrans, ncolcovp1, covp1, ncolcovpois, covpois, zeroindex) {
    .Call('ziphsmm_hmm_cov_viterbi', PACKAGE = 'ziphsmm', parm, M, y, ncolcovpi, covpi, ncolcovtrans, covtrans, ncolcovp1, covp1, ncolcovpois, covpois, zeroindex)
}

hsmm_cov_viterbi <- function(parm, M, y, trunc, zeroindex, ncolcovp, covp, ncolcovpi, covpi, ncolcovomega, covomega, ncolcovp1, covp1, ncolcovpois, covpois, dt_dist) {
    .Call('ziphsmm_hsmm_cov_viterbi', PACKAGE = 'ziphsmm', parm, M, y, trunc, zeroindex, ncolcovp, covp, ncolcovpi, covpi, ncolcovomega, covomega, ncolcovp1, covp1, ncolcovpois, covpois, dt_dist)
}

ziploglik_nocov <- function(delta, gamma, theta, lambda, y, ntimes) {
    .Call('ziphsmm_ziploglik_nocov', PACKAGE = 'ziphsmm', delta, gamma, theta, lambda, y, ntimes)
}

retrieve_nocov <- function(parm, M) {
    .Call('ziphsmm_retrieve_nocov', PACKAGE = 'ziphsmm', parm, M)
}

zipnegloglik_nocov <- function(parm, M, y, ntimes) {
    .Call('ziphsmm_zipnegloglik_nocov', PACKAGE = 'ziphsmm', parm, M, y, ntimes)
}

forwardbackward <- function(Pi, P, nodeprob, y, ntimes) {
    .Call('ziphsmm_forwardbackward', PACKAGE = 'ziphsmm', Pi, P, nodeprob, y, ntimes)
}

grad_ziploglik_nocov <- function(delta, gamma, theta, lambda, y, ntimes) {
    .Call('ziphsmm_grad_ziploglik_nocov', PACKAGE = 'ziphsmm', delta, gamma, theta, lambda, y, ntimes)
}

grad_zipnegloglik_nocov <- function(parm, M, y, ntimes) {
    .Call('ziphsmm_grad_zipnegloglik_nocov', PACKAGE = 'ziphsmm', parm, M, y, ntimes)
}

ziploglik_cov <- function(delta, gamma, thetaparm, lambdaparm, y, x, ntimes) {
    .Call('ziphsmm_ziploglik_cov', PACKAGE = 'ziphsmm', delta, gamma, thetaparm, lambdaparm, y, x, ntimes)
}

retrieve_cov <- function(parm, M, ncolx) {
    .Call('ziphsmm_retrieve_cov', PACKAGE = 'ziphsmm', parm, M, ncolx)
}

zipnegloglik_cov <- function(parm, y, covariates, M, ntimes) {
    .Call('ziphsmm_zipnegloglik_cov', PACKAGE = 'ziphsmm', parm, y, covariates, M, ntimes)
}

grad_ziploglik_cov <- function(delta, gamma, thetaparm, lambdaparm, y, x, ntimes) {
    .Call('ziphsmm_grad_ziploglik_cov', PACKAGE = 'ziphsmm', delta, gamma, thetaparm, lambdaparm, y, x, ntimes)
}

grad_zipnegloglik_cov <- function(parm, y, covariates, M, ntimes) {
    .Call('ziphsmm_grad_zipnegloglik_cov', PACKAGE = 'ziphsmm', parm, y, covariates, M, ntimes)
}

nupdate_to_nbetween <- function(nupdate, nmin, dim, ntimes) {
    .Call('ziphsmm_nupdate_to_nbetween', PACKAGE = 'ziphsmm', nupdate, nmin, dim, ntimes)
}

sgd_zip_nocov <- function(parm, y, M, ntimes, nmin, nupdate, power, rate) {
    .Call('ziphsmm_sgd_zip_nocov', PACKAGE = 'ziphsmm', parm, y, M, ntimes, nmin, nupdate, power, rate)
}

sgd_zip_cov <- function(parm, y, x, M, ntimes, nmin, nupdate, power, rate) {
    .Call('ziphsmm_sgd_zip_cov', PACKAGE = 'ziphsmm', parm, y, x, M, ntimes, nmin, nupdate, power, rate)
}

hsmm_gen_np <- function(dim, M, pi, theta, zeroprop, omega, dt) {
    .Call('ziphsmm_hsmm_gen_np', PACKAGE = 'ziphsmm', dim, M, pi, theta, zeroprop, omega, dt)
}

hsmm_cov_gen_np <- function(parm, dt, M, dim, zeroindex, ncolcovpi, covpi, ncolcovomega, covomega, ncolcovp1, covp1, ncolcovpois, covpois) {
    .Call('ziphsmm_hsmm_cov_gen_np', PACKAGE = 'ziphsmm', parm, dt, M, dim, zeroindex, ncolcovpi, covpi, ncolcovomega, covomega, ncolcovp1, covp1, ncolcovpois, covpois)
}

hsmm_viterbi_np <- function(y, M, trunc, pi, theta, omega, dm, zeroprop) {
    .Call('ziphsmm_hsmm_viterbi_np', PACKAGE = 'ziphsmm', y, M, trunc, pi, theta, omega, dm, zeroprop)
}

hsmm_cov_viterbi_np <- function(parm, dm, M, trunc, y, zeroindex, ncolcovpi, covpi, ncolcovomega, covomega, ncolcovp1, covp1, ncolcovpois, covpois) {
    .Call('ziphsmm_hsmm_cov_viterbi_np', PACKAGE = 'ziphsmm', parm, dm, M, trunc, y, zeroindex, ncolcovpi, covpi, ncolcovomega, covomega, ncolcovp1, covp1, ncolcovpois, covpois)
}

hsmmloglik_nocov <- function(dt, delta, gamma, theta, lambda, y, ntimes, trunc) {
    .Call('ziphsmm_hsmmloglik_nocov', PACKAGE = 'ziphsmm', dt, delta, gamma, theta, lambda, y, ntimes, trunc)
}

hsmmretrieve_nocov <- function(parm, M, trunc) {
    .Call('ziphsmm_hsmmretrieve_nocov', PACKAGE = 'ziphsmm', parm, M, trunc)
}

hsmmnegloglik_nocov <- function(parm, M, y, ntimes, trunc) {
    .Call('ziphsmm_hsmmnegloglik_nocov', PACKAGE = 'ziphsmm', parm, M, y, ntimes, trunc)
}

gradhsmmloglik_nocov <- function(dt, delta, gamma, theta, lambda, y, ntimes, trunc) {
    .Call('ziphsmm_gradhsmmloglik_nocov', PACKAGE = 'ziphsmm', dt, delta, gamma, theta, lambda, y, ntimes, trunc)
}

gradhsmmnegloglik_nocov <- function(parm, M, y, ntimes, trunc) {
    .Call('ziphsmm_gradhsmmnegloglik_nocov', PACKAGE = 'ziphsmm', parm, M, y, ntimes, trunc)
}

hsmmloglik_cov <- function(dt, delta, gamma, thetaparm, lambdaparm, y, x, ntimes, trunc) {
    .Call('ziphsmm_hsmmloglik_cov', PACKAGE = 'ziphsmm', dt, delta, gamma, thetaparm, lambdaparm, y, x, ntimes, trunc)
}

hsmmretrieve_cov <- function(parm, M, ncolx, trunc) {
    .Call('ziphsmm_hsmmretrieve_cov', PACKAGE = 'ziphsmm', parm, M, ncolx, trunc)
}

hsmmnegloglik_cov <- function(parm, y, covariates, M, ntimes, trunc) {
    .Call('ziphsmm_hsmmnegloglik_cov', PACKAGE = 'ziphsmm', parm, y, covariates, M, ntimes, trunc)
}

gradhsmmloglik_cov <- function(dt, delta, gamma, thetaparm, lambdaparm, y, x, ntimes, trunc) {
    .Call('ziphsmm_gradhsmmloglik_cov', PACKAGE = 'ziphsmm', dt, delta, gamma, thetaparm, lambdaparm, y, x, ntimes, trunc)
}

gradhsmmnegloglik_cov <- function(parm, y, covariates, M, ntimes, trunc) {
    .Call('ziphsmm_gradhsmmnegloglik_cov', PACKAGE = 'ziphsmm', parm, y, covariates, M, ntimes, trunc)
}

sgd_hsmm_nocov <- function(parm, y, M, ntimes, nmin, nupdate, power, rate, trunc) {
    .Call('ziphsmm_sgd_hsmm_nocov', PACKAGE = 'ziphsmm', parm, y, M, ntimes, nmin, nupdate, power, rate, trunc)
}

sgd_hsmm_cov <- function(parm, y, x, M, ntimes, nmin, nupdate, power, rate, trunc) {
    .Call('ziphsmm_sgd_hsmm_cov', PACKAGE = 'ziphsmm', parm, y, x, M, ntimes, nmin, nupdate, power, rate, trunc)
}

getallexpm <- function(tpm, udiff) {
    .Call('ziphsmm_getallexpm', PACKAGE = 'ziphsmm', tpm, udiff)
}

locate <- function(interval, udiff) {
    .Call('ziphsmm_locate', PACKAGE = 'ziphsmm', interval, udiff)
}

get_c <- function(xi, diffvec, udiff) {
    .Call('ziphsmm_get_c', PACKAGE = 'ziphsmm', xi, diffvec, udiff)
}

get_taun <- function(Q, udiff, C) {
    .Call('ziphsmm_get_taun', PACKAGE = 'ziphsmm', Q, udiff, C)
}

fb_cont <- function(Pi, P, nodeprob, dim, ntimes, timeindex, udiff, expms) {
    .Call('ziphsmm_fb_cont', PACKAGE = 'ziphsmm', Pi, P, nodeprob, dim, ntimes, timeindex, udiff, expms)
}

hmm_gen_cont <- function(dim, M, pi, a, theta, zeroprop, timeindex) {
    .Call('ziphsmm_hmm_gen_cont', PACKAGE = 'ziphsmm', dim, M, pi, a, theta, zeroprop, timeindex)
}

ziploglik_nocov_cont <- function(delta, gamma, theta, lambda, y, ntimes, timeindex, udiff, expms) {
    .Call('ziphsmm_ziploglik_nocov_cont', PACKAGE = 'ziphsmm', delta, gamma, theta, lambda, y, ntimes, timeindex, udiff, expms)
}

retrieve_nocov_cont <- function(parm, M) {
    .Call('ziphsmm_retrieve_nocov_cont', PACKAGE = 'ziphsmm', parm, M)
}

zipnegloglik_nocov_cont <- function(parm, M, y, ntimes, timeindex, udiff) {
    .Call('ziphsmm_zipnegloglik_nocov_cont', PACKAGE = 'ziphsmm', parm, M, y, ntimes, timeindex, udiff)
}

grad_ziploglik_nocov_cont <- function(delta, gamma, theta, lambda, y, ntimes, timeindex, udiff, expms) {
    .Call('ziphsmm_grad_ziploglik_nocov_cont', PACKAGE = 'ziphsmm', delta, gamma, theta, lambda, y, ntimes, timeindex, udiff, expms)
}

grad_zipnegloglik_nocov_cont <- function(parm, M, y, ntimes, timeindex, udiff) {
    .Call('ziphsmm_grad_zipnegloglik_nocov_cont', PACKAGE = 'ziphsmm', parm, M, y, ntimes, timeindex, udiff)
}

hmm_viterbi_cont <- function(pi, a, theta, M, y, zeroprop, timeindex, udiff, expms) {
    .Call('ziphsmm_hmm_viterbi_cont', PACKAGE = 'ziphsmm', pi, a, theta, M, y, zeroprop, timeindex, udiff, expms)
}

hmm_cov_gen_cont <- function(parm, M, dim, ncolcovpi, covpi, ncolcovtrans, covtrans, ncolcovp1, covp1, ncolcovpois, covpois, zeroindex, timeindex) {
    .Call('ziphsmm_hmm_cov_gen_cont', PACKAGE = 'ziphsmm', parm, M, dim, ncolcovpi, covpi, ncolcovtrans, covtrans, ncolcovp1, covp1, ncolcovpois, covpois, zeroindex, timeindex)
}

ziploglik_cov_cont <- function(delta, gamma, thetaparm, lambdaparm, y, x, ntimes, timeindex, udiff, expms) {
    .Call('ziphsmm_ziploglik_cov_cont', PACKAGE = 'ziphsmm', delta, gamma, thetaparm, lambdaparm, y, x, ntimes, timeindex, udiff, expms)
}

retrieve_cov_cont <- function(parm, M, ncolx) {
    .Call('ziphsmm_retrieve_cov_cont', PACKAGE = 'ziphsmm', parm, M, ncolx)
}

zipnegloglik_cov_cont <- function(parm, y, covariates, M, ntimes, timeindex, udiff) {
    .Call('ziphsmm_zipnegloglik_cov_cont', PACKAGE = 'ziphsmm', parm, y, covariates, M, ntimes, timeindex, udiff)
}

grad_ziploglik_cov_cont <- function(delta, gamma, thetaparm, lambdaparm, y, x, ntimes, timeindex, udiff, expms) {
    .Call('ziphsmm_grad_ziploglik_cov_cont', PACKAGE = 'ziphsmm', delta, gamma, thetaparm, lambdaparm, y, x, ntimes, timeindex, udiff, expms)
}

grad_zipnegloglik_cov_cont <- function(parm, y, covariates, M, ntimes, timeindex, udiff) {
    .Call('ziphsmm_grad_zipnegloglik_cov_cont', PACKAGE = 'ziphsmm', parm, y, covariates, M, ntimes, timeindex, udiff)
}

hmm_cov_viterbi_cont <- function(parm, M, y, ncolcovpi, covpi, ncolcovtrans, covtrans, ncolcovp1, covp1, ncolcovpois, covpois, zeroindex, timeindex, udiff, expms) {
    .Call('ziphsmm_hmm_cov_viterbi_cont', PACKAGE = 'ziphsmm', parm, M, y, ncolcovpi, covpi, ncolcovtrans, covtrans, ncolcovp1, covp1, ncolcovpois, covpois, zeroindex, timeindex, udiff, expms)
}

